package com.nakkaya.arp;

import java.lang.String;
import java.util.logging.Logger;
import java.util.Vector;
import java.util.Iterator;

//system arp table
public class ArpTable{
    Vector<Host> arpTable = new Vector<Host>();

    public ArpTable( ){
    }

    //add to arp table
    public void add( Host host ){
	arpTable.add( host );
    }

    //iterate throug arp table return mac address for
    //given ip else return null
    public String getMAC( String ip ){

	for( Host host : arpTable ){
	    if ( host.ipAddr.equals( ip ) == true ){
		return host.macId;
	    }
	}
	
	return null;
    }

    public void setMac(String ip , String newMac ){
	for( Host host : arpTable ){
	    if ( host.ipAddr.equals( ip ) == true ){
		host.macId = newMac;
	    }
	}
    }

    //check if given host is in table
    public boolean contains(Host test){
	return arpTable.contains( test );
    }

    //return arp table
    public Vector getTable(){
	return arpTable;
    }

    public int getSize(){
	return arpTable.size();
    }
    
    public Host getRow( int row ){
	Host host = (Host)arpTable.get( row );
	return host;
    }

    //print arp table
    public String toString(){
	StringBuilder table = new StringBuilder();

	for( Host host : arpTable ){
	    table.append( host + "\n");
	}

	return table.toString();
    }
}
