package com.nakkaya.network;

import java.util.StringTokenizer;
import java.lang.Process;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Enumeration;
import java.net.NetworkInterface;
import java.net.InetAddress;
import java.net.URLConnection;
import java.net.URL;
import java.util.prefs.Preferences;
import java.lang.Thread;
import java.util.logging.Logger;

public class Network{
    static public String CURRENT_OS = "GENERIC";

    Logger logger = Logger.getLogger("SysLog");
    Preferences preferences = Preferences.userRoot();    
    
    public String gateway = " - - - ";
    public String adapter = " - - - ";
    public String localIP = " - - - ";
    public String wanIP = " - - - ";

    public Network(){
	getNetworkInfo();
    }

    public void getNetworkInfo(){
	new Thread( new Runnable() {
		public void run() {
		    while(true){
			try{

			    //detects os needed by findIP
			    findGateway();
			    findIP();
			    findWanIP();
			    
			    Thread.sleep(10000);
			}catch (Exception e) {
			    logger.warning( e.toString() );
			}
		    }
		    
		}}).start();

//  	System.out.printf("The gateway is %s\n", gateway);
//  	System.out.printf("The adapter is %s\n", adapter);
//  	System.out.printf("The local ip is %s\n", localIP);
//  	System.out.printf("The wan ip is %s\n", wanIP);
    }

    public void findWanIP(){
	try{

	    URL checkip = new URL("http://checkip.dyndns.org/");
	    URLConnection yc = checkip.openConnection();
	    yc.setConnectTimeout( 2000 );
	    yc.setReadTimeout( 2000 );
	    BufferedReader in = new BufferedReader
		( new InputStreamReader( yc.getInputStream()));

	    String inputLine;
	    String content = new String();
	    
	    while ((inputLine = in.readLine()) != null) 
		content = content + inputLine;

	    wanIP = content.substring
		(content.indexOf(": ")+2 , content.indexOf("</body>"));
	    in.close();
	    
	}catch( Exception e ) {
	    wanIP = " - - - ";
	    logger.warning( e.toString() );
	}
    }

    public void findIP(){
	try{

	    NetworkInterface nif = NetworkInterface.getByName( adapter );
	    Enumeration nifAddresses = nif.getInetAddresses();
	    InetAddress inet = (InetAddress)nifAddresses.nextElement();
	    
	    if ( preferences.get("OS",CURRENT_OS ).equals( "Linux" ) == true)
		inet = (InetAddress)nifAddresses.nextElement();

	    localIP = inet.getHostAddress();

	}catch( Exception e ) { 
	    logger.warning( e.toString() );
	    localIP = new String();
	}
    }

    public void findGateway(){
	try{
	    Process result = Runtime.getRuntime().exec("netstat -rn");
	    
	    BufferedReader output = new BufferedReader
		(new InputStreamReader(result.getInputStream()));
	    
	    String line = output.readLine();
	    while(line != null){
		//get default route depending on the os.
		if ( line.startsWith("default") == true )
		    break;		

		if ( line.startsWith("0.0.0.0") == true )
		    break;

		line = output.readLine();
	    }


 	    StringTokenizer st = new StringTokenizer( line );
 	    st.nextToken();
 	    gateway = st.nextToken();
	    
	    //skip enough tokens to grap adapter for local IP.
	    if ( preferences.get("OS",CURRENT_OS ).equals( "OSX" ) == true){
		st.nextToken();
		st.nextToken();
		st.nextToken();
	    }
	    if ( preferences.get("OS",CURRENT_OS ).equals( "Linux" )== true){
		st.nextToken();
		st.nextToken();
		st.nextToken();
		st.nextToken();
		st.nextToken();
	    }

	    adapter = st.nextToken();

	}catch( Exception e ) { 
	    logger.warning( e.toString() );
	    gateway = new String();
	    adapter = new String();
	}
    }
}
